#include "classeditor.h"
#include "ui_classeditor.h"


ClassEditor::ClassEditor(QWidget *parent) :
    QMainWindow(parent),
    ui(new Ui::ClassEditor)
{
    ui->setupUi(this);

    
    
    //    settdialog = new SettingsDialog(this);
  /////////////////////////////////////////////////////  settdialog.show();
    sql.setDatabaseName(tr("an_db"));

/*
    field = new TableField(tr(""), this);
    field->setNotNull(true);
    field->setDefaultValue(tr(""));

    table = new SqlTable (tr("NewTable"), this);
    table->setName(tr("NewTable"));
    table->fields().at(0)->setNotNull(true);
    if (!(table->setPrimaryKey(tr("ID")))) {
         ui->label_3->setText(table->lastError());
    }
    else  ui->label_3->setText(table->primaryKey());
    table->append(field);

    field = new TableField(tr(""), this);
    field->setNotNull(true);
    field->setDefaultValue(tr(""));
    table->append(field);

    field = new TableField(tr(""), this);
    field->setNotNull(true);
    field->setDefaultValue(tr(""));
    table->append(field);

    field = new TableField(tr(" ()"), this);
    field->setNotNull(true);
    field->setType(tr("INTEGER"));
    field->setDefaultValue(tr("1"));
    table->append(field);

    field = new TableField(tr(" "), this);
    field->setNotNull(false);
    field->setType(tr("DATE"));
    field->setDefaultValue(tr("NULL"));
    table->append(field);

    ui->label_2->setText(table->name());
    ui->label->setText(table->fields().at(0)->sqlString());
    ui->label_4->setText(table->sqlString());
   ////// ui->lineEdit->insert(table->sqlString());

*/
    /**********************************************

    QTextDocument *document;
    // = ui->textEdit->document();
    QTextCursor *cursor;

    document = ui->textEdit->document();
    cursor = new QTextCursor(document);
    cursor->movePosition(QTextCursor::Start);
QTextCharFormat format(cursor->charFormat());
//format.setFontFamily("Courier");
format.setFontFamily("Arial");
//format.setFontItalic(false);

format.setFontWeight(QFont::Normal);
QTextCharFormat boldFormat = format;
boldFormat.setFontWeight(QFont::Bold);

QTextCharFormat italicFormat = format;
//format.setFontFamily("Courier");
//     format.setFontFamily("Arial");
italicFormat.setFontItalic(true);

cursor->insertText(table->sqlString(), format);

****************************************************/

QString errorString;

sql.setDatabaseName(tr("an_db"));
sql.setHostName(tr("localhost"));
sql.setUserName(tr("an"));
sql.setPassword(tr("393939"));

bool ok;
ok = sql.connect();
if (!ok) {
                            QMessageBox::critical( //     .
                                                                            this,                      //  .
                                                                            QObject::tr("Database Error"),   // .
                                                                            sql.lasError());         //  .

                     }
else {

    QMessageBox::information( //     .
                                                    this,                      //  .
                                                    QObject::tr("Database Connect"),   // .
                                                    QObject::tr("     ."));         //  .





}

/*
ok = sql.createTable(table);
if (!ok) {
                            QMessageBox::critical( //     .
                                                                            this,                      //  .
                                                                            QObject::tr("Database Error"),   // .
                                                                            sql.lasError());         //  .
         }
else {

    QMessageBox::information( //     .
                                                    this,                      //  .
                                                    QObject::tr("Database Connect"),   // .
                                                    QObject::tr("     ."));         //  .
     }



*/

ok = sql.createListOfClassesTable();

if (!ok) {
                            QMessageBox::critical( //     .
                                                                            this,                      //  .
                                                                            QObject::tr("Database Error"),   // .
                                                                            sql.lasError());         //  .

                     }
else {

    QMessageBox::information( //     .
                                                    this,                      //  .
                                                    QObject::tr("Database Create"),   // .
                                                    QObject::tr("   ."));         //  .
    }




ok = sql.createDescriptionOfClassesTable();

if (!ok) {
                            QMessageBox::critical( //     .
                                                                            this,                      //  .
                                                                            QObject::tr("Database Error"),   // .
                                                                            sql.lasError());         //  .

                     }
else {

    QMessageBox::information( //     .
                                                    this,                      //  .
                                                    QObject::tr("Database Create"),   // .
                                                    QObject::tr("   ."));         //  .
    }







model = new QSqlTableModel(); //   
tableForInstance = new QTableView();
mymodel = new MyModel(this);
modelForPointers = new ModelForPointers(this); // //     

//modelForDescription = new QSqlTableModel(this);
modelForDescription = new ModelForDescriptionTable(this);


/////////////////model->setTable(tr("ListOfClasses"));
mymodel->setTable(tr("ListOfClasses"));
modelForDescription->setTable(tr("DescriptionOfClasses"));
modelForDescription->setEditStrategy(QSqlTableModel::OnFieldChange);

/////model->setEditStrategy(QSqlTableModel::OnManualSubmit);

modelForPointers->setEditStrategy(QSqlTableModel::OnManualSubmit);
modelForPointers->setTable(tr("DescriptionOfClasses"));




//mymodel->setEditStrategy(QSqlTableModel::OnFieldChange);



//////////////////model->setSort(0, Qt::AscendingOrder);
mymodel->setSort(0, Qt::AscendingOrder);
modelForDescription->setSort(0, Qt::AscendingOrder);
modelForPointers->setSort(0, Qt::AscendingOrder);

//       model->setFilter(tr("__ = '7' and _ = 'i09090909'"));
////////////////////model->select();
mymodel->select();
// modelForPointers->select();




/////////////////////////model->setHeaderData(1, Qt::Horizontal, tr(" "));
mymodel->setHeaderData(1, Qt::Horizontal, tr(" "));



////////////////////////model->setHeaderData(2, Qt::Horizontal, tr(" "));
mymodel->setHeaderData(2, Qt::Horizontal, tr(" "));
mymodel->setHeaderData(4, Qt::Horizontal, tr(""));

//ui->tableView_3->setModel(modelForPointers);

//ui->tableView->setModel(model);
ui->tableView->setModel(mymodel);
//tableForDescription = new QTableView();
ui->tableView_2->setModel(modelForDescription);
ui->tableView_2->setAlternatingRowColors(true);
ui->tableView_2->resizeColumnsToContents();
//tableForDescription->show();


ui->tableView->setAlternatingRowColors(true);
ui->tableView->resizeColumnsToContents();

ui->tableView->hideColumn(0);
ui->tableView->hideColumn(3);
ui->tableView->hideColumn(2);

/*
ui->tableView_2->hideColumn(0);
ui->tableView_2->hideColumn(5);
ui->tableView_2->hideColumn(2);
*/
ui->tableView_2->setItemDelegateForColumn(3, &classTableDelegate);

currIndexOfClassesTable = mymodel->index(0, 1);
QModelIndex index_temp;



currClassID = mymodel->data(mymodel->index(0,0)).toString();
QItemSelectionModel *selectionModel = ui->tableView->selectionModel();

QModelIndex topLeft;
QModelIndex bottomRight;

     topLeft = mymodel->index(0, 0, QModelIndex());
     bottomRight = mymodel->index(0, 1, QModelIndex());

QItemSelection selection(topLeft, bottomRight);
selectionModel->select(selection, QItemSelectionModel::Select);


QString class_indx, class_instance;
QString str_fltr = tr("ClassIdentifer = ");
class_indx = mymodel->data(mymodel->index(0,0)).toString();
class_instance = mymodel->data(mymodel->index(0,3)).toString();

currInctanceTable = class_instance; //
modelForDescription->setInctance(class_instance); //       -
//class_instance.append(tr("_inctance"));
str_fltr.append(class_indx);
str_fltr.append(tr(" AND FieldType <> \"pointer\""));

model->setTable(class_instance);
//model->setTable(tr("memory"));
model->setEditStrategy(QSqlTableModel::OnManualSubmit);
model->select();
tableForInstance->setModel(model);
tableForInstance->resizeColumnsToContents();
tableForInstance->setWindowTitle(class_instance);
tableForInstance->show();

modelForDescription->setFilter(str_fltr);
modelForDescription->select();
ui->tableView_2->resizeColumnsToContents();


 str_fltr = tr("ClassIdentifer = ");
 modelForPointers->setInctance(class_instance);  //       -
 str_fltr.append(class_indx);
 str_fltr.append(tr(" AND FieldType = \"pointer\""));
// str_fltr.append( tr(" FieldType = pointer "));



 modelForPointers->setFilter(str_fltr);
modelForPointers->select();
ui->tableView_3->setModel(modelForPointers);
ui->tableView_3->resizeColumnsToContents();

//connect(ui->tableView, SIGNAL(clicked(const QModelIndex)), this, SLOT(on_tableView_clicked(const QModelIndex)));
connect(mymodel, SIGNAL(dataChanged(QModelIndex,QModelIndex)), this, SLOT(on_myModel_dataChanged(QModelIndex,QModelIndex)));
connect(modelForDescription, SIGNAL(dataChanged(QModelIndex,QModelIndex)), this, SLOT(on_modelForDescription_dataChanged(QModelIndex,QModelIndex)));
//connect(ui->newClassAction, SIGNAL(triggered(bool)), this, SLOT(on_pushButton_clicked(bool)));
connect(ui->action_ID, SIGNAL(triggered(bool)), this, SLOT(on_action_ID_triggered(bool)));
connect(ui->action_showAlias, SIGNAL(triggered(bool)), this, SLOT(on_action_showAlias_triggered(bool))); //  
connect(ui->action_showInstance, SIGNAL(triggered(bool)), this, SLOT(on_action_showInstance_triggered(bool))); //   
connect(ui->action_removeSelectedFields, SIGNAL(triggered()), this, SLOT(on_pushButton_4_clicked())); //   
connect(ui->action_removeAllFields, SIGNAL(triggered()), this, SLOT(on_pushButton_5_clicked())); //   
connect(ui->action_removeSelectedClasses, SIGNAL(triggered()), this, SLOT(on_pushButton_2_clicked())); //   
connect(ui->action_removeAllClasses, SIGNAL(triggered()), this, SLOT(on_action_removeAllClasses())); //   
connect(ui->action_newClass, SIGNAL(triggered()), this, SLOT(on_pushButton_clicked())); //   
connect(ui->action_newField, SIGNAL(triggered()), this, SLOT(on_pushButton_3_clicked())); //   
connect(ui->action_newPointer, SIGNAL(triggered()), this, SLOT(on_action_newPointer())); //       -
// connect(ui->action_newPointer, SIGNAL(triggered()), this, SLOT(on_pushButton_3_clicked())); //       -
connect(modelForDescription, SIGNAL(field_changed()), this, SLOT(on_field_changed())); //     
connect(ClassEditor::modelForPointers, SIGNAL(field_changed()), this, SLOT(on_field_changed())); //     


}











ClassEditor::~ClassEditor()
{
    delete ui;
    delete model;
    delete tableForInstance;
 //    delete field;
   // delete settdialog;
}

void ClassEditor::changeEvent(QEvent *e)
{
    QMainWindow::changeEvent(e);
    switch (e->type()) {
    case QEvent::LanguageChange:
        ui->retranslateUi(this);
        break;
    default:
        break;
    }
}


/*
void  ClassEditor::addNewClass(){

    int row = model->rowCount();

    model->insertRows(row, 1);
    model->setData(model->index(row, 1), tr("New class")); //     " "


    // model->setData(model->index(row, 1), tr("   "));
    // model->setData(model->index(row, 2) , tr("  ,    1"));


    model->submitAll();

    row = model->rowCount();
    QString tmp_str;
    int i_tmp;
    i_tmp = model->data(model->index(row-1, 0)).toInt();
    tmp_str = model->data(model->index(row-1, 0)).toString(); //   -  

    tmp_str.append(tr("_Inctance"));
    model->setData(model->index(row-1, 3), tmp_str );  //     

    model->submitAll();
    mymodel->select();


}
*/

void  ClassEditor::addNewClass_new(){

    int row = mymodel->rowCount();

    mymodel->insertRows(row, 1);
    mymodel->setData(mymodel->index(row, 1), QVariant(tr("New class")), Qt::EditRole); //     " "


    mymodel->submitAll();
    row = mymodel->rowCount();
    QString tmp_str1, sql_str;
    int i_tmp1;
    i_tmp1 = mymodel->data(mymodel->index(row-1, 0)).toInt();
    tmp_str1 = mymodel->data(mymodel->index(row-1, 0)).toString(); //   -  

    tmp_str1.append(tr("_Inctance"));
    SqlTable* tbl;
    tbl = new SqlTable(tmp_str1); //   
    sql_str = tbl->sqlString();
    bool ok;

    ok = sql.createTable(tbl);

    if (!ok) {
                                QMessageBox::critical( //     .
                                                                                this,                      //  .
                                                                                QObject::tr("Database Error"),   // .
                                                                                sql.lasError());         //  .
                                delete tbl;
                                mymodel->removeRow(row-1);
                                mymodel->submitAll();
                                mymodel->select();
                                ui->tableView_2->resizeRowsToContents();
                                return; //    

                         }

    delete tbl;
    mymodel->setData(mymodel->index(row-1, 3), QVariant(tmp_str1), Qt::EditRole);  //     



    // model->setData(model->index(row, 1), tr("   "));
    // model->setData(model->index(row, 2) , tr("  ,    1"));


    //mymodel->submitAll();

    //row = mymodel->rowCount();


  //mymodel->select();


}


void ClassEditor::addNewField(){
    // QSqlRecord rec = mymodel->record(1);
     //bool ok;
     //ok = rec.isEmpty();
     //QString currientClassID;
     //currientClassID = rec.value(1).toString();
    QString Inctance_str; //  -    
    QString query_str = tr("ALTER TABLE ");
    QString db_error;
    QSqlQuery q;
    int currRow = ClassEditor::currIndexOfClassesTable.row(); //
    Inctance_str = mymodel->data(mymodel->index(currRow, 3)).toString();
    query_str.append( Inctance_str);
    query_str.append(tr(" ADD COLUMN `New field` CHAR(30)"));
    bool ok = q.prepare(query_str);

    ok = q.exec();
    if (!ok) {
                                QMessageBox::critical( //     .
                                                                                this,                      //  .
                                                                                QObject::tr("Database Error"),   // .
                                                                                q.lastError().text()); //  .

                                                                return; //    

                         }

    int row = modelForDescription->rowCount();
    modelForDescription->insertRows(row, 1);
    modelForDescription->onlySetData(modelForDescription->index(row, 5), QVariant(currClassID), Qt::EditRole);
    modelForDescription->onlySetData(modelForDescription->index(row, 4), QVariant(tr("NULL")), Qt::EditRole);

    modelForDescription->submitAll();

    delete model;
    delete tableForInstance;
    model = new QSqlTableModel();
    tableForInstance = new QTableView();
    model->setTable(Inctance_str);
    model->setEditStrategy(QSqlTableModel::OnManualSubmit);
    tableForInstance->setModel(model);
    tableForInstance->setWindowTitle(Inctance_str);
    tableForInstance->show();
}



void ClassEditor::addNewPointer(){  //  ,       -
    QString Inctance_str; //  -    
    QString query_str = tr("ALTER TABLE ");
    QString db_error;
    QSqlQuery q;
    int currRow = ClassEditor::currIndexOfClassesTable.row(); //
    Inctance_str = mymodel->data(mymodel->index(currRow, 3)).toString();
    query_str.append( Inctance_str);
    query_str.append(tr(" ADD COLUMN `lass-container ID` CHAR(30)"));
    bool ok = q.prepare(query_str);

    ok = q.exec();
    if (!ok) {
                                QMessageBox::critical( //     .
                                                                                this,                      //  .
                                                                                QObject::tr("Database Error"),   // .
                                                                                q.lastError().text()); //  .

                                                                return; //    

                         }


    int row = ClassEditor::modelForPointers->rowCount();
    modelForPointers->insertRows(row, 1);

    modelForPointers->onlySetData(modelForPointers->index(row, 1), QVariant(tr("lass-container ID")), Qt::EditRole);
    modelForPointers->onlySetData(modelForPointers->index(row, 3), QVariant(tr("pointer")), Qt::EditRole);
    modelForPointers->onlySetData(modelForPointers->index(row, 5), QVariant(currClassID), Qt::EditRole);
    modelForPointers->onlySetData(modelForPointers->index(row, 4), QVariant(tr("NULL")), Qt::EditRole);


    modelForPointers->submitAll();

    ClassEditor::refreshInctance();









}





//   
void ClassEditor::on_pushButton_clicked(){
//int i;
//i++;
/////ClassEditor::addNewClass();
ClassEditor::addNewClass_new();
 mymodel->select();
//ui->tableView->setModel(mymodel);

}

void ClassEditor::on_tableView_clicked(const QModelIndex & index ){
    int i, row, column;
    i++;
    row = index.row();
    column = index.column();
    currIndexOfClassesTable = index;
    QModelIndex index_tmp, index_instance;
    QString tmp_str, filter_str, instance_str;
   index_tmp = ui->tableView->model()->index(row, 0);
   index_instance = ui->tableView->model()->index(row, 3);
   tmp_str = ui->tableView->model()->data(index_tmp).toString();
   instance_str = ui->tableView->model()->data(index_instance).toString();
   modelForDescription->setInctance(instance_str); //       -
   modelForPointers->setInctance(instance_str);



 //  instance_str.append(tr("_inctance"));
/*
   Inctance_model.clear();
   Inctance_model.setTable(instance_str);
    Inctance_model.select();
    tableForInstance_new.setModel(&Inctance_model);
    tableForInstance_new.show();
*/
  // model->clear();
   tableForInstance->close();
   delete model;
   delete tableForInstance;
   model = new QSqlTableModel();
   tableForInstance = new QTableView();
   model->setTable(instance_str);
   model->setEditStrategy(QSqlTableModel::OnManualSubmit);
   tableForInstance->setModel(model);

   model->select();
tableForInstance->setWindowTitle(instance_str);
tableForInstance->show();

   //   tableForInstance.setModel(model);
   tableForInstance->resizeColumnsToContents();

   currClassID = tmp_str;
  // ui->label->setText(QVariant(currIndexOfClassesTable.row()).toString());
   filter_str = tr("ClassIdentifer = ");
   filter_str.append(tmp_str);
   filter_str.append(tr(" AND FieldType <> \"pointer\""));
   modelForDescription->setFilter(filter_str);
   modelForDescription->select();
   ui->tableView_2->resizeColumnsToContents();

   filter_str = tr("ClassIdentifer = ");
   filter_str.append(tmp_str);
   filter_str.append(tr(" AND FieldType = \"pointer\""));
   modelForPointers->setFilter(filter_str);
   modelForPointers->select();
   ui->tableView_3->resizeColumnsToContents();




   i++;
}



void ClassEditor::on_pushButton_2_clicked(){ //    " "
    QModelIndex model_index;
    QItemSelectionModel *selectionModel = ui->tableView->selectionModel();
    QModelIndexList indexes = selectionModel->selectedIndexes();
    QList<int> selectedRows;
    selectedRows.clear();
    foreach (model_index, indexes){ //    
        if (!selectedRows.contains(model_index.row()) && (model_index.column()==1))  selectedRows.append(model_index.row()); //        

    }
    qSort(selectedRows.begin(),selectedRows.end(), qGreater<int>()); //    


    for (int m =0; m < selectedRows.size(); ++m){

     ClassEditor::removeClass(selectedRows.at(m));



    }
 mymodel->submitAll();
    ClassEditor::modelForDescription->select();

}

void ClassEditor::on_pushButton_3_clicked(){         //    " "
    int i;
    i++;
    ClassEditor::addNewField();
    ClassEditor::modelForDescription->select();
    ui->tableView_2->resizeColumnsToContents();
}


void ClassEditor::on_pushButton_4_clicked(){         //    " "
   // int i;
    QModelIndex model_index;
    QItemSelectionModel *selectionModel = ui->tableView_2->selectionModel();
    QModelIndexList indexes = selectionModel->selectedIndexes();
    //QModelIndexList indexes_fo_first_col; //     ( )
    //model_index = mymodel->selec;
    //modelList = ui->tableView->SelectItems;
    //i = indexes.size();
    QList<int> selectedRows;
    //indexes_fo_first_col.clear();
    /*
    foreach (model_index, indexes){ //    
        if (!indexes_fo_first_col.contains(model_index) && (model_index.column()==1))  indexes_fo_first_col.append(model_index); //        

    }
*/
    selectedRows.clear();
    foreach (model_index, indexes){ //    
        if (!selectedRows.contains(model_index.row()) && (model_index.column()==1))  {
            selectedRows.append(model_index.row()); //        
        }
    }

    qSort(selectedRows.begin(),selectedRows.end(), qGreater<int>()); //    

    QString Inctance_str; //  -
    Inctance_str = mymodel->data(mymodel->index(ClassEditor::currIndexOfClassesTable.row(), 3)).toString();
    for (int m =0; m < selectedRows.size(); ++m){


        QString query_str;
        QString field_name_str; //   
        QSqlQuery q;

        query_str.clear();


        field_name_str = modelForDescription->data(modelForDescription->index(selectedRows.at(m), 1)).toString();

        query_str.append(tr("ALTER TABLE "));
        query_str.append(Inctance_str);
        query_str.append(tr(" DROP COLUMN `"));
        query_str.append(field_name_str);
        query_str.append(tr("`"));
        q.prepare(query_str);
        bool ok = q.exec();
        if (!ok) {
                                    QMessageBox::critical( //     .
                                                                                    this,                      //  .
                                                                                    QObject::tr("Database Error"),   // .
                                                                                    q.lastError().text()); //  .

                                                                    return; //    

                             }



        modelForDescription->removeRow(selectedRows.at(m));

    }
    delete model;
    delete tableForInstance;
    model = new QSqlTableModel();
    tableForInstance = new QTableView();
    model->setTable(Inctance_str);
    model->setEditStrategy(QSqlTableModel::OnManualSubmit);
    tableForInstance->setModel(model);
    tableForInstance->setWindowTitle(Inctance_str);
    tableForInstance->show();
    //i = selectedRows.size();

    //if (i > 0) model_index = indexes.at(0);
}


void ClassEditor::on_pushButton_5_clicked(){         //    "  "
int row;
row = ClassEditor::modelForDescription->rowCount();
ClassEditor::modelForDescription->removeRows(0, row);
ClassEditor::modelForDescription->submitAll();
}

void ClassEditor::on_myModel_dataChanged( const QModelIndex & topLeft, const QModelIndex & bottomRight ){

int i;
i++;
ui->tableView->resizeColumnsToContents();





}

void ClassEditor::on_modelForDescription_dataChanged ( const QModelIndex & topLeft, const QModelIndex & bottomRight ){
    ui->tableView_2->resizeColumnsToContents();

    /*
    QString instance_str;
    instance_str = mymodel->data(mymodel->index(ClassEditor::currIndexOfClassesTable.row(), 3)).toString();
    tableForInstance->close();
    delete model;
    delete tableForInstance;
    model = new QSqlTableModel();
    tableForInstance = new QTableView();
    model->setTable(instance_str);
    model->setEditStrategy(QSqlTableModel::OnManualSubmit);
    tableForInstance->setModel(model);

    model->select();
 tableForInstance->setWindowTitle(instance_str);
 tableForInstance->show();
*/
}

void ClassEditor::on_action_ID_triggered(bool is_checked){          //     " ID"
if (is_checked) ui->tableView->showColumn(0);
else ui->tableView->hideColumn(0);
ui->tableView->resizeColumnsToContents();
}

void ClassEditor::on_action_showAlias_triggered(bool is_checked){     //     " "
    if (is_checked) ui->tableView->showColumn(2);
    else ui->tableView->hideColumn(2);
    ui->tableView->resizeColumnsToContents();
}

void ClassEditor::on_action_showInstance_triggered(bool is_checked){ //     "  "
    if (is_checked) ui->tableView->showColumn(3);
    else ui->tableView->hideColumn(3);
    ui->tableView->resizeColumnsToContents();
}



void ClassEditor::on_action_removeAllClasses(){ //     "  "
    int row;
    row = ClassEditor::mymodel->rowCount();
    for (int m=0; m < row; ++m){
    ClassEditor::removeClass(0);
    //ClassEditor::mymodel->removeRows(0, row);
}
    ClassEditor::mymodel->submitAll();
    ClassEditor::modelForDescription->select();
}

void ClassEditor::removeClass(int class_row){ //   ,      class_row
    QModelIndex index_tmp;
    QString tmp_str, filter_str;
   index_tmp = ui->tableView->model()->index(class_row, 0);
   tmp_str = ui->tableView->model()->data(index_tmp).toString();
   currClassID = tmp_str;
  // ui->label->setText(QVariant(currIndexOfClassesTable.row()).toString());
   filter_str = tr("ClassIdentifer = ");
   filter_str.append(tmp_str);
   modelForDescription->setFilter(filter_str); //   
    ClassEditor::on_pushButton_5_clicked(); //     
     mymodel->removeRow(class_row); //    
     mymodel->submitAll(); //  
   ui->tableView->resizeColumnsToContents();
   ui->tableView_2->resizeColumnsToContents();

}


void ClassEditor::on_field_changed(){ //   
    ClassEditor::refreshInctance();
}




void ClassEditor::refreshInctance(){ //   -

    QString Inctance_str; //  -
    Inctance_str = mymodel->data(mymodel->index(ClassEditor::currIndexOfClassesTable.row(), 3)).toString();
    delete model;
    delete tableForInstance;
    model = new QSqlTableModel();
    tableForInstance = new QTableView();
    model->setTable(Inctance_str);
    model->setEditStrategy(QSqlTableModel::OnManualSubmit);
    model->select();
    tableForInstance->setModel(model);
    tableForInstance->setWindowTitle(Inctance_str);
    tableForInstance->resizeRowsToContents();
    tableForInstance->show();

}




void ClassEditor::on_action_newPointer(){
    ClassEditor::addNewPointer();
    ClassEditor::modelForPointers->select();
    ui->tableView_3->resizeColumnsToContents();

}

